c      $Id: x05f.fm4 11680 2011-03-27 17:57:51Z airwin $
c      Draws a histogram from sample data
c
c      Copyright (C) 2004  Alan W. Irwin
c
c      This file is part of PLplot.
c
c      PLplot is free software; you can redistribute it and/or modify
c      it under the terms of the GNU Library General Public License as
c      published by the Free Software Foundation; either version 2 of the
c      License, or (at your option) any later version.
c
c      PLplot is distributed in the hope that it will be useful,
c      but WITHOUT ANY WARRANTY; without even the implied warranty of
c      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c      GNU Library General Public License for more details.
c
c      You should have received a copy of the GNU Library General Public
c      License along with PLplot; if not, write to the Free Software
c      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

      implicit none
      include 'plplot_parameters.h'

      integer i
      integer NPTS
      parameter ( NPTS = 2047 )
      real*8 data(NPTS), delta
c      Process command-line arguments
      call plparseopts(PL_PARSE_FULL)

c      Initialize plplot
      call plinit()
c      Fill up data points

      delta = 2.0d0 * PI / dble (NPTS)
      do i=1,NPTS
        data(i)=sin(delta*dble (i-1))
      enddo

      call plcol0(1)
      call plhist(NPTS, data, -1.1d0, 1.1d0, 44, 0)
      call plcol0(2)
      call pllab('#frValue','#frFrequency',
     &  '#frPLplot Example 5 - Probability function of Oscillator')

      call plend
      end
